import { API, DynamicPlatformPlugin, HAP, Logging, PlatformAccessory, PlatformConfig } from "homebridge";
import { myQApi, myQDevice } from "@hjdhjd/myq";
import { myQMqtt } from "./myq-mqtt.js";
import { myQOptionsInterface } from "./myq-config.js";
interface myQPollInterface {
    count: number;
    maxCount: number;
}
export declare class myQPlatform implements DynamicPlatformPlugin {
    private readonly accessories;
    readonly api: API;
    config: myQOptionsInterface;
    private readonly configOptions;
    private readonly configuredAccessories;
    readonly hap: HAP;
    readonly log: Logging;
    readonly mqtt: myQMqtt;
    readonly myQ: myQApi;
    private pollingTimer;
    readonly pollOptions: myQPollInterface;
    private unsupportedDevices;
    constructor(log: Logging, config: PlatformConfig, api: API);
    configureAccessory(accessory: PlatformAccessory): void;
    private discoverAndSyncAccessories;
    private updateAccessories;
    poll(delay?: number): void;
    optionEnabled(device: myQDevice | null, option?: string, defaultReturnValue?: boolean): boolean;
    debug(message: string, ...parameters: unknown[]): void;
}
export {};
